#!/usr/bin/env python
# -*- coding: UTF-8 -*-
##
##    Copyright (C) 2005 manatlan manatlan[at]gmail(dot)com
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published
## by the Free Software Foundation; version 2 only.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
# Python module jbrout.py
# Autogenerated from jbrout.glade
# Generated on Tue May 24 08:20:16 2005

# Warning: Do not delete or modify comments related to context
# They are required to keep user's code
import pygtk
pygtk.require('2.0')

import sys,time # to hack thread on win32
if float("%d.%d" % (sys.version_info[0],sys.version_info[1]))<2.4 :
    print "jbrout need python2.4 or +"
    sys.exit()

import os
import gtk
from SimpleGladeApp import SimpleGladeApp

glade_dir = ""

# Put your modules and data here
#=============================================================================
try:
    os.chdir(os.path.split(sys.argv[0])[0])
except:
    pass

try:
    __version__ = open("version.txt").read().strip()
except:
    __version__ = "svn"

from plugger import PluginsManager # needed for plugins (so they can get pluggers)
from common import _   # to be present for plugins dynamic import

from common import cd2rd # for selecteur

#~ from jplugin import JPlugin # needed for plugins (so they can get pluggers)
from commongtk import WinShow,WinWait,AlbumCommenter,InputBox,MessageBox,InputQuestion
from db import JBrout,Buffer

import urllib,time,datetime,sys
import traceback, string


def myExceptHook(type, value, tb):
   sys.__excepthook__(type, value, tb)
   lines = traceback.format_exception(type, value, tb)
   MessageBox(None,"ERROR JBROUT",string.join(lines))

def beep(m):
    print m


class PlugConf:
    def __init__(self,myConf,myName):
        self.__conf = myConf
        self.__name = myName
    def __setitem__(self,n,v):
        self.__conf[self.__name+"."+n] = v
    def __getitem__(self,n):
        return self.__conf[self.__name+"."+n]

class JPlugin:
    # self.parent : fenetre parente

    @staticmethod
    def initialize(w):
        JPlugin.__win = w

    def __init__(self,name):
        self.conf = PlugConf(JBrout.conf,name)
        self.parent = JPlugin.__win.main_widget

    def MessageBox(self,t,m):
        MessageBox(self.parent,t,m)
    def InputBox(self,t,m):
        InputBox(self.parent,t,m)
    def InputQuestion(self,m):
        InputQuestion(self.parent,m)

    def showProgress(self,c=None,m=None,msg=None):
        JPlugin.__win.showProgress(c,m,msg)


from listview import ListView
class Selecteur(ListView):

    def init(self,list):
        list.sort( cmp=lambda x,y: -cmp(x.date,y.date))
        ListView.init(self,list)

    def getTitle(self, item,choix):
        node = self.list[item]

        a= [
            ", ".join(node.tags),
            node.comment,
            node.folderName,
            cd2rd(node.date),
            node.name
        ] [choix]

        return a



    def getImage(self, item):
        pn = self.list[item]
        i= Buffer.get(pn.file,pn.getThumb,self.refreshItem,item)
        if JBrout.db.isInBasket(pn)!=None:
            ii = i.copy()
            Buffer.pbBasket2.copy_area(0, 0, 15, 13, ii, 3, 3)
            return ii
        else:
            return i


    def mouseClick(self,item,event):
        self.parentWin.on_selecteur_mouseClick(self,item,event)

    def onDrop(self,item,*args):
        self.parentWin.on_selecteur_drop(self,item,*args)


class DateDB(gtk.TreeStore):
    def __init__(self):
        gtk.TreeStore.__init__(self, str,gtk.gdk.Pixbuf,str)

    def init(self,offset=0,today=False):
        self.clear()

        if offset!=0:
            y=self.__selectedDate.year
            m=self.__selectedDate.month
            d=self.__selectedDate.day


            if abs(offset)==1:
                m+=offset
                if m>12:
                    m=1
                    y+=1
                if m<1:
                    m=12
                    y-=1
            elif abs(offset)==12:
                y+=(offset/12)

            self.__selectedDate = datetime.datetime(y,m,d)

        if today:
            t=datetime.datetime.now()
            self.__selectedDate = datetime.datetime(t.year,t.month,1)

        ym = self.__selectedDate.strftime("%Y%m")
        ln = JBrout.db.select("""//photo[substring(@date,1,6)="%s"]""" % ym)
        jour={}
        for node in ln:
            jour[ node.date[:8] ] = node

        jours = [i for i in jour.keys()]
        jours.sort()
        for i in jours:
            node = jour[i]
            d= datetime.datetime(int(i[:4]),int(i[4:6]),int(i[6:8]))
            date = d.strftime("%A %d")
            ymd = d.strftime("%Y%m%d")
            self.append(None,[date,node.getThumb().scale_simple(80,80,gtk.gdk.INTERP_NEAREST),ymd])

        return self.__selectedDate.strftime("%B %Y")

class TreeDB(gtk.TreeStore):
    def __init__(self):
        gtk.TreeStore.__init__(self, str,str,object,str)
        #~ self.fill(None,None)

        self.init()

    def init(self):
        """ Init the tree and the basket (which will be refreshed) """
        self.clear()

        self.zapfill( JBrout.db.getRootFolder() ,None)

        self.__iterBasket = None
        JBrout.db.refreshBasket()
        self.activeBasket()

    def zapfill(self,node,attach):
        """ same as fill, but zap the beginning of the useless tree, and branch to fill """
        if node != None:
            folders = node.getFolders()
            photos = node.getPhotos()
            if len(folders)==1 and len(photos)==0: # zap the useless folders
                return self.zapfill(folders[0],attach)
            else:
                return self.fill(node,attach)

    def fill(self,node,attach):
        """ rebuild treestore from the nodefolder 'node' to the iter 'attach' """
        if node != None:
            folders = node.getFolders()

            new = self.add(attach,node )

            for i in folders:
                self.fill(i,new)

            return new
    #~ def fill(self,node,attach):
        #~ ii = self.append(attach,["hell",1,1])
        #~ self.append(ii,["bonobo",1,1])
        #~ self.append(ii,["banaba",1,1])
        #~ self.append(ii,["ukkkk",1,1])
        #~ ii = self.append(attach,["aaahello",1,1])
        #~ self.append(ii,["aabonobo",1,1])
        #~ self.append(ii,["aabaaanaba",1,1])
        #~ self.append(ii,["aaukkkk",1,1])

    def find(self,node):
        """ return the 'iter' of the node in the model or None """
        def _lookInside(model, path, iter0, rechNode):
            node = model.get(iter0)
            if node and node.file == rechNode.file:
                _lookInside.ite = iter0
                return True
        _lookInside.ite=None
        self.foreach( _lookInside, node )
        return _lookInside.ite

    def expander(self,tree):
        """ do the expand/collapse from the model(node) to the treeview 'tree' """
        def _expander(model, path, iter0, tree):
            node = model.get(iter0)
            if node and node.expand:
                tree.expand_row(path,False)
        self.foreach( _expander, tree )


    def get(self,it):
        """ get the 'node' of the iter 'it' """
        node = self.get_value(it,2)
        return node

    def set(self,it,node):
        """ set the 'node' of the iter 'it' """
        self.set_value(it,0,node.name)
        self.set_value(it,1,len(node.getPhotos()))
        self.set_value(it,2,node)
        color = len(node.getPhotos())>0 and "#000000" or "#888888"
        self.set_value(it,3,color)

    def add(self,it,node):
        """ append the 'node' to the iter """
        color = len(node.getPhotos())>0 and "#000000" or "#888888"
        return self.append(it,[node.name,len(node.getPhotos()),node,color])


    def activeBasket(self):
        if JBrout.db.isBasket():
            if self.__iterBasket:
                self.remove(self.__iterBasket)

            nb = len(JBrout.db.getBasket())
            self.__iterBasket = self.prepend(None,["basket",nb,None,"#FF3333"])
        else:
            if self.__iterBasket:
                self.remove(self.__iterBasket)
            self.__iterBasket = None

class TreeTags(gtk.TreeStore):
    def __init__(self):
        gtk.TreeStore.__init__(self, str,object,str)
        #~ self.fill(None,None)
        self.init()

    def init(self):
        self.clear()
        self.fill( JBrout.tags.getRootTag() ,None)

    def fill(self,node,attach):
        """ rebuild treestore from the catgnode 'node' to the iter 'attach' """
        catgs = node.getCatgs()
        tags = node.getTags()

        new = self.add(attach,node)
        for i in catgs:
            self.fill(i,new)

        for i in tags:
            self.add(new,i)

        #~ for i in catgs:
            #~ new = self.add(attach,i)
            #~ self.fill(i,new)

        #~ for i in tags:
            #~ self.add(attach,i)


    #~ def find(self,node):
        #~ """ return the 'iter' of the node in the model or None """
        #~ def _lookInside(model, path, iter0, rechNode):
            #~ node = model.get(iter0)
            #~ if node.file == rechNode.file:
                #~ _lookInside.ite = iter0
                #~ return True
        #~ _lookInside.ite=None
        #~ self.foreach( _lookInside, node )
        #~ return _lookInside.ite

    def expander(self,tree):
        """ do the expand/collapse from the model(node) to the treeview 'tree' """
        def _expander(model, path, iter0, tree):
            node = model.get(iter0)
            if node.__class__.__name__ == "CatgNode" and node.expand:
                tree.expand_row(path,False)
        self.foreach( _expander, tree )


    def get(self,it):
        """ get the 'node' of the iter 'it' """
        node = self.get_value(it,1)
        return node

    #~ def set(self,it,node):
        #~ """ set the 'node' of the iter 'it' """
        #~ self.set_value(it,0,node.name)
        #~ self.set_value(it,1,len(node.getPhotos()))
        #~ self.set_value(it,2,node)

    def add(self,it,node):
        """ append the 'node' to the iter """
        if node.__class__.__name__ == "TagNode":
            return self.append(it,[node.name,node,"#000088"])
        else:
            return self.append(it,["[%s]" % node.name,node,"#888888"])




#=============================================================================

# From here through main() codegen inserts/updates a class for
# every top-level widget in the .glade file.

class Window(SimpleGladeApp):
    def __init__(self, glade_path="jbrout.glade", root="window", domain=None):
        glade_path = os.path.join(glade_dir, glade_path)
        SimpleGladeApp.__init__(self, glade_path, root, domain)

    def new(self):
        #context Window.new {
        #=============================================================================
        JBrout.db.setNormalizeName( JBrout.conf["normalizeName"] or False )
        table = Selecteur( self,JBrout.modify)

        self.main_widget.set_redraw_on_allocate(False)
        self.comment=AlbumCommenter(JBrout.modify)
        b=gtk.VBox()
        b.show()
        b.pack_start(self.comment,False,True,2)
        b.pack_start(table)
        self.hpaned1.add(b)
        self.hpaned1.set_focus_chain([table.tbl])
        #~ self.hpaned1.resize=False
        #~ self.hpaned1.realize()
        #~ self.hpaned1.set_resize_mode(gtk.RESIZE_PARENT)
        #~ table.set_resize_mode(gtk.RESIZE_PARENT)
        #~ table.tbl.set_resize_mode(gtk.RESIZE_PARENT)
        table.show()
        table.setFocus()
        self.tbl = table
        TARGET_STRING = 0
        TARGET_ROOTWIN = 1

        self.main_widget.set_title("JBrout "+__version__)

        if JBrout.modify:
            TARGETS = [
            ('MY_TREE_MODEL_ROW', gtk.TARGET_SAME_WIDGET, 0),
            #~ ('text/plain', 0, 1),
            ('TEXT', 0, 2),
            ('STRING', 0, 3),
            ]
            self.treeviewdb.enable_model_drag_source( gtk.gdk.BUTTON1_MASK,
                                                    [TARGETS[0]],
                                                    gtk.gdk.ACTION_DEFAULT|
                                                    gtk.gdk.ACTION_COPY)
            self.treeviewdb.enable_model_drag_dest(TARGETS,                 # can receive from self and selecteur
                                                 gtk.gdk.ACTION_DEFAULT)


            self.btn_addFolder.drag_dest_set(gtk.DEST_DEFAULT_ALL, [('text/plain', 0, 1),], # drag from os
                                            gtk.gdk.ACTION_COPY | gtk.gdk.ACTION_MOVE)


            self.treeviewtags.enable_model_drag_source( gtk.gdk.BUTTON1_MASK,
                                                    TARGETS,
                                                    gtk.gdk.ACTION_DEFAULT|
                                                    gtk.gdk.ACTION_COPY)
            self.treeviewtags.enable_model_drag_dest([TARGETS[0]],          # can receive from self only
                                                 gtk.gdk.ACTION_DEFAULT)

            self.treeviewtags.get_selection().set_mode(gtk.SELECTION_MULTIPLE)

            self.btn_addFolder.show()
        else:
            self.btn_addFolder.hide()

        ################
        #~ cell_renderer = gtk.CellRendererText()
        #~ column = gtk.TreeViewColumn("folder", cell_renderer,text=0,foreground=3)
        ################

        def filename(column, cell, model, iter):
            cell.set_property('text', model.get_value(iter, 0))
            cell.set_property('foreground', model.get_value(iter, 3))
            cell.set_property('xalign', 0)
            #~ cell.set_property('xpad', 1)
        def pixbuf(column, cell, model, iter):
            if model.get_value(iter, 2)==None:
                cell.set_property('pixbuf', Buffer.pbBasket)
            else:
                cell.set_property('pixbuf', Buffer.pbFolder)
            cell.set_property('width', 16)
            cell.set_property('xalign', 0)

        cellpb = gtk.CellRendererPixbuf()
        column = gtk.TreeViewColumn("albums", cellpb)
        column.set_cell_data_func(cellpb, pixbuf)
        cell = gtk.CellRendererText()
        column.pack_start(cell, True)
        column.set_cell_data_func(cell, filename)
        ################

        self.treeviewdb.append_column(column)
        cell_renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("nb", cell_renderer,text=1)
        self.treeviewdb.append_column(column)

        store = TreeDB()
        self.treeviewdb.set_model( store )
        store.expander(self.treeviewdb)


        cell_renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Tags", cell_renderer,text=0,foreground=2)
        self.treeviewtags.append_column(column)

        store = TreeTags()
        self.treeviewtags.set_model( store )
        store.expander(self.treeviewtags)


        cell_renderer = gtk.CellRendererText()
        column = gtk.TreeViewColumn("Dates", cell_renderer,text=0)
        self.selectDate.append_column(column)
        cellpb = gtk.CellRendererPixbuf()
        column = gtk.TreeViewColumn("View", cellpb,pixbuf=1)
        self.selectDate.append_column(column)

        m = DateDB()
        m.init(today=True)
        self.selectDate.set_model(m)

        smenu=gtk.Menu()
        gitem=None
        for i in self.tbl.choix:
            item = gtk.RadioMenuItem(gitem,i)
            if not gitem: gitem = item
            idx = self.tbl.choix.index(i) + 1
            item.connect("activate",self.on_affichage_select,idx )
            if idx == (JBrout.conf["viewSelection"] or 5):
                self.tbl.setAff(idx)
                item.set_active(True)
            item.show()
            smenu.append(item)
        self.menuitem3.set_submenu(smenu)

        #~ w,h = self.treeviewdb.size_request()
        #~ w2,h2 = self.tbl.size_request()
        #~ w = w+w2+30
        #~ h = max(h,h2)
        #~ a=self.main_widget.allocation
        #~ a=gtk.gdk.Rectangle(0,0,600,600)
        #~ print w,h
        #~ self.main_widget.size_allocate( a )
        #~ self.main_widget.set_size_request(1024,760)

        self.hpaned1.set_position( JBrout.conf["hpaned"] or 160 )
        self.main_widget.resize( JBrout.conf["width"] or 800,JBrout.conf["height"] or 600 )

        Window.MODEBASKET="basket"
        Window.MODEFOLDER="folder"
        Window.MODETIME="time"
        Window.MODETAG="tag"

        self.mode = Window.MODEFOLDER
        self.__winwait=None
        #~ gdkwin = self.window
        #=============================================================================

        #context Window.new }

    #context Window custom methods {
    #--- Write your own methods here ---#
    def on_affichage_select(self,widget,idx):
        self.tbl.setAff(idx)
        JBrout.conf["viewSelection"]=idx
        return True

    def showProgress(self,cur=None,max=None,msg=None):
        """
            to show a current process is pending ... 3 types of call:
            - showProgress(True) : block principal window (no msg, no win)
            - showProgress(cur,max,msg) : block principal window, and show a progress bar cur/max + msg
            - showProgress() : release principal window
        """
        if cur==None and max==None:
            if self.__winwait:
                self.__winwait.destroy()
                self.__winwait=None

                self.main_widget.window.set_cursor(None)
                #~ self.main_widget.set_sensitive(True)
        else:
            if self.__winwait==None:
                self.__winwait = WinWait(self.main_widget)

                cursor = gtk.gdk.Cursor(gtk.gdk.WATCH)
                self.main_widget.window.set_cursor(cursor)
                #~ self.main_widget.set_sensitive(False)

            if max==None:
                self.__winwait.hide()
            else:
                self.__winwait.show()
                if cur<=0: cur=0.01
                elif cur>=max:cur=max
                percent = float(cur)/max
                self.__winwait.set(percent,msg)

            while gtk.events_pending():
                gtk.main_iteration()

    def SetSelection(self,title,ln,mode):
        self.mode = mode
        self.main_widget.set_title("%s (%d photo(s)) " % (title,len(ln)))
        self.tbl.init(ln)
        if mode != Window.MODEFOLDER:
            self.comment.hide()
        self.tbl.setFocus()

    ###################################################################################
    ## TREEVIEW DB
    ###################################################################################
    def select(self,model,iter0,all=True):
        if iter0:
            self.showProgress(True)
            try:
                path = model.get_path(iter0)
                node = model.get(iter0)
                if node:
                    # on a real folder
                    if all:
                        ln = node.getAllPhotos()
                    else:
                        ln = node.getPhotos()
                    name = node.name
                    mode = Window.MODEFOLDER
                    self.comment.set(node)
                else:
                    # on the basket (perhaps ?! ;-)
                    ln = JBrout.db.getBasket()
                    name = "basket"
                    mode = Window.MODEBASKET

                self.treeviewdb.expand_to_path( path )
                self.treeviewdb.set_cursor( path )
                self.SetSelection(name,ln,mode)
            finally:
                self.showProgress()


    def on_menu_rename(self,e):
        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        node = model.get(iter0)

        self.showProgress(True)
        ret = InputBox(self.main_widget,"rename",node.name)
        self.showProgress()

        if ret and ret != node.name:
            if node.rename(ret):
                model.set(iter0,node)

                # delete from basket the photo which are moved
                JBrout.db.refreshBasket()
                model.activeBasket()

                self.select(model,iter0)

    def on_menu_new_folder(self,e):
        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        node = model.get(iter0)

        self.showProgress(True)
        ret = InputBox(self.main_widget,"new folder","")
        self.showProgress()

        if ret:
            newNode = node.createNewFolder(ret)
            if newNode!=None:
                iter1=model.add(iter0,newNode)
                self.select(model,iter1)

    def on_menu_refresh(self,e):
        Buffer.clear()

        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        node = model.get(iter0)

        parentIter = model.iter_parent(iter0)
        path = node.file

        self.on_drop_folders_from_os(model,[path])

    def on_menu_delete_from_db(self,e):
        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        node = model.get(iter0)

        parentIter = model.iter_parent(iter0)
        node.remove()
        model.remove(iter0)

        # delete from basket the photo which are moved
        JBrout.db.refreshBasket()
        model.activeBasket()

        self.select(model,parentIter)

    def on_menu_delete_from_disk(self,e):
        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        node = model.get(iter0)
        nbphotos = len(node.getAllPhotos())
        parentIter = model.iter_parent(iter0)

        self.showProgress(True)
        if nbphotos==0:
            question = "Are you sure to delete this folder ?"
        else:
            question = "Are you sure to delete this folder (and its %d photo(s))?" % nbphotos
        ret = InputQuestion(self.main_widget,question)
        self.showProgress()
        if ret:
            if node.delete():
                model.remove(iter0)

                # delete from basket the photo which are moved
                JBrout.db.refreshBasket()
                model.activeBasket()

                self.select(model,parentIter)


    def on_menu_remove_basket(self,e):
        JBrout.db.clearBasket()
        model = self.treeviewdb.get_model()
        model.activeBasket()
        self.tbl.refresh()


    def on_menu_select_only(self,e):
        treeselection = self.treeviewdb.get_selection()
        model, iter0 = treeselection.get_selected()
        self.select(model,iter0,False)

    def on_drop_photos(self,model,iter0):
        node = model.get(iter0)
        for i in self.tbl.getSelected():
            nodeFolderParent = i.getParent()
            if nodeFolderParent.file != node.file: # don't move from the same folder ;-)
                if i.moveToFolder(node):
                    self.tbl.remove(i)

                    # to set the counter from source
                    iterFolderParent = model.find( nodeFolderParent)
                    model.set(iterFolderParent,nodeFolderParent)

        # to set the counter to dest
        model.set(iter0,node)

        # delete from basket the photo which are moved
        JBrout.db.refreshBasket()
        model.activeBasket()

    def on_drop_folders_from_os(self,model,files):
        self.showProgress(0,1,"import")
        try:
            newNodeFolder=None

            importedTags={}


            for folder in files:
                if os.path.isdir(folder):
                    iterator = JBrout.db.add( folder,importedTags )
                    total = iterator.next()
                    for nb in iterator:
                        if nb>=0:
                            self.showProgress(nb,total,"Importing %d/%d"%(nb,total))
                    if nb:
                        newNodeFolder = nb

            if newNodeFolder: # at least one folder as be imported
                tags = importedTags.keys()
                if tags:
                    nbNewTags = JBrout.tags.updateImportedTags( tags )
                    if nbNewTags: # some are news !!!
                        tmodel = self.treeviewtags.get_model()
                        tmodel.init()
                        tmodel.expander(self.treeviewtags)
                        MessageBox(None,"info","%d tag(s) were added !" % nbNewTags)

                model.init( ) # redraw the full tree (+basket)
                model.expander(self.treeviewdb)
                newIterFolder = model.find( newNodeFolder )

                self.select(model,newIterFolder)
        finally:
            self.showProgress()



    def on_move_folder(self,model,ifrom,ito):
        nfrom = model.get(ifrom)
        nto = model.get(ito)
        if nto!=None:
            # drop on a real folder

            if nfrom !=None:
                # drag from a real folder
                if  InputQuestion(self.main_widget,"Are you sure to move this folder here ?"):
                    new = nfrom.moveToFolder(nto)
                    if new:
                        model.remove(ifrom)
                        iter0=model.fill(new,ito)

                        self.select(model,iter0)

                        # delete from basket the photo which are moved
                        JBrout.db.refreshBasket()
                        model.activeBasket()
            else:
                # drag from the basket
                MessageBox(None,"info","Can't drag the basket to a folder")
        else:
            # drop on the basket
            if nfrom !=None:
                # drag from a real folder
                for node in nfrom.getAllPhotos():
                    JBrout.db.addToBasket(node)
                model.activeBasket()

    ###################################################################################
    ## SELECTEUR / LISTVIEW
    ###################################################################################

    def on_selecteur_mouseClick(self,sel,item,event):
        if event.button==3 and event.type == gtk.gdk.BUTTON_PRESS:

            def makeItem(nom,callback,selecteur):
                item = gtk.ImageMenuItem(nom)
                item.connect("activate",callback,selecteur)
                item.show()
                return item

            ln = sel.getSelected()

            # control if we can add/remove selected photos from basket -> can*
            # control if there is a readOnly file
            canBasketRemove=False
            canBasketAdd=False
            isThereAReadOnlyFile = False
            for node in ln:
                if JBrout.db.isInBasket(node)!=None:
                    canBasketRemove = True
                else:
                    canBasketAdd = True

                if node.isReadOnly:
                    isThereAReadOnlyFile = True

            #detect if modification are allowed
            canModify = JBrout.modify and (not isThereAReadOnlyFile)

            menu = gtk.Menu()
            if canBasketAdd: # there are pictures which could be added to basket
                menu.append( makeItem("Add to Basket", self.on_selecteur_menu_add_to_basket,sel) )
            if canBasketRemove: # there are pictures which could be removed basket
                menu.append( makeItem("Remove From Basket", self.on_selecteur_menu_remove_from_basket,sel) )

            if len(ln)==1: # there is only one selected picture
                menu.append( makeItem("Select this folder", self.on_selecteur_menu_select_folder,sel ))

            menu2 = gtk.Menu()
            isEntries = False
            for id,plug,text,cde,alter in JBrout.plugins.getEntries():

                # try to detect if plugin are enable or not
                if canModify:
                    enableMenu = True
                else:
                    # jbrout doesn't allow modification
                    # so, only plugins not alter'able are enabled
                    enableMenu = not alter

                if enableMenu:
                    item = gtk.ImageMenuItem( text )
                    menu2.append(item)
                    item.connect("activate",self.on_selecteur_menu_select_plugin,sel,id)
                    isEntries = True
                #~ if (not JBrout.modify) and (not alter) or JBrout.modify:

                    #~ item = gtk.ImageMenuItem( text )
                    #~ menu2.append(item)
                    #~ item.connect("activate",self.on_selecteur_menu_select_plugin,sel,id)
                    #~ isEntries = True
            if isEntries:
                smenu2=gtk.ImageMenuItem("Operations")
                smenu2.set_submenu(menu2)
                smenu2.show_all()
                menu.append(smenu2)

            # build the "delete tags" sub menu
            if canModify:
                # search all tags from selection, to present the delete tags menu
                d=[]
                for pnode in ln:
                    for t in pnode.tags:
                        if t not in d:
                            d.append(t)

                if d:
                    d.sort()
                    menu3 = gtk.Menu()
                    for tag in d:
                        item = gtk.ImageMenuItem( tag )
                        item.connect("activate",self.on_selecteur_menu_delete_tag,sel,tag)
                        menu3.append(item)
                    item = gtk.ImageMenuItem( "** ALL **" )
                    item.connect("activate",self.on_selecteur_menu_delete_tag,sel,"*")
                    menu3.append(item)
                    smenu3=gtk.ImageMenuItem("Delete tag")
                    smenu3.set_submenu(menu3)
                    smenu3.show_all()
                    menu.append(smenu3)

                menu.append( makeItem("delete", self.on_selecteur_menu_delete,sel ))

            menu.popup(None,None,None,event.button,event.time)
            return 1
        elif event.button==1 and event.type == gtk.gdk._2BUTTON_PRESS:
            WinShow(sel.list,item)
            return 1
            #~ self.tbl.select(item)

    def on_selecteur_menu_delete_tag(self,b,sel,tag):
        ln=sel.getSelected()
        try:
            for i in ln:
                self.showProgress(ln.index(i),len(ln),"Deleting tags")
                if tag=="*":
                    i.clearTags()
                else:
                    i.delTag(tag)
        finally:
            self.showProgress()
        sel.refresh()

    def on_selecteur_menu_add_to_basket(self,b,sel):
        ln = sel.getSelected()
        for node in ln:
            print JBrout.db.addToBasket(node)

        model=self.treeviewdb.get_model()
        model.activeBasket()
        sel.refresh()

    def on_selecteur_menu_remove_from_basket(self,b,sel):
        ln = sel.getSelected()
        for node in ln:
            JBrout.db.removeFromBasket(node)
            if self.mode == Window.MODEBASKET:
                sel.remove(node)

        model=self.treeviewdb.get_model()
        model.activeBasket()
        sel.refresh()

    def on_selecteur_menu_select_folder(self,b,sel):
        ln = sel.getSelected()
        assert len(ln)==1
        node = ln[0]

        # select its folder
        folderNode = node.getParent()
        model = self.treeviewdb.get_model()
        iterFolder = model.find( folderNode)
        self.select(model,iterFolder)

        # and select the selected photo
        ll=[i.file for i in sel.list]
        sel.select( ll.index(node.file) )

    #~ def on_selecteur_menu_comment(self,b,sel):
        #~ ln = sel.getSelected()
        #~ WinShow(ln,0,True)
        #~ sel.refresh()

    def on_selecteur_menu_delete(self,b,sel):
        l = sel.getSelected()
        ret = InputQuestion(None,"Delete %d photo(s) are you sure ?" % len(l))
        if ret:
            model = self.treeviewdb.get_model()
            for i in l:
                file = i.file
                folderNode = i.getParent()

                if i.delete():

                    # remove from buffer images
                    Buffer.remove(file)

                    # remove from the selection widget
                    sel.remove(i)

                    # to set the counter from source
                    iterFolderParent = model.find( folderNode)
                    model.set(iterFolderParent,folderNode)

            # delete from basket the photo which are moved
            JBrout.db.refreshBasket()
            model.activeBasket()

            # refresh the selection widget
            sel.refresh()



    def on_selecteur_menu_select_plugin(self,b,sel,id):
        l = sel.getSelected()
        for i in l:
            Buffer.remove(i.file)
        self.showProgress(True)
        try:
            ret=JBrout.plugins.do(id,l)
        finally:
            self.showProgress()
        if ret:
            JBrout.db.refreshBasket()   # perhaps a file was redated and renamed
            self.treeviewdb.get_model().activeBasket()
            sel.refresh()
            sel.refresh() # on win, the first call do nothing

    def on_selecteur_drop(self,sel,item,*args):
        model = self.treeviewtags.get_model()
        l=[]
        for i in self.dragTags:
            node = model.get(i)
            if node.__class__.__name__ == "TagNode":
                l.append(node.name)
            else:
                l.extend( [i.name for i in node.getAllTags()] )

        if l:
            ln = sel.getSelected()
            try:
                for i in ln:
                    self.showProgress(ln.index(i),len(ln),"Adding tags")
                    if i.isReadOnly:
                        beep("can't add tag to a readonly picture")
                    else:
                        i.addTags(l)
            finally:
                self.showProgress()
            sel.refresh()
        #~ context, x, y, selection, info, time = args
        #~ dragFrom =context.get_source_widget().__class__.__name__
        #~ print dragFrom

    ###################################################################################
    ## TREEVIEW TAGS
    ###################################################################################
    def on_menu_add_tag(self,e):
        treeselection = self.treeviewtags.get_selection()
        model,paths = treeselection.get_selected_rows()
        if len(paths)==1:
            iter0 = model.get_iter(paths[0])
            node = model.get(iter0)

            self.showProgress(True)
            ret = InputBox(self.main_widget,"new tag","")
            self.showProgress()

            if ret:
                newt = node.addTag(ret.strip())
                if newt:
                    newiter=model.add(iter0,newt)
                    path=model.get_path(newiter)
                    self.treeviewtags.expand_to_path( path )
                    self.treeviewtags.set_cursor( path )
                else:
                    MessageBox(None,"no","tag already exists")

    def on_menu_add_catg(self,e):
        treeselection = self.treeviewtags.get_selection()
        model,paths = treeselection.get_selected_rows()
        if len(paths)==1:
            iter0 = model.get_iter(paths[0])
            node = model.get(iter0)

            self.showProgress(True)
            ret = InputBox(self.main_widget,"new catg","")
            self.showProgress()

            if ret:
                newt = node.addCatg(ret.strip())
                if newt:
                    newiter=model.add(iter0,newt)
                    path=model.get_path(newiter)
                    self.treeviewtags.expand_to_path( path )
                    self.treeviewtags.set_cursor( path )
                else:
                    MessageBox(None,"no","Category already exists")

    def on_menu_delete_tags(self,e):
        treeselection = self.treeviewtags.get_selection()
        model,paths = treeselection.get_selected_rows()
        if len(paths)==1:
            iter0 = model.get_iter(paths[0])
            node = model.get(iter0)

            if node.__class__.__name__ == "TagNode":
                ln = JBrout.db.select("""//photo[t="%s"]""" % node.name)
                if len(ln)>0:
                    MessageBox(None,"no","This tag is in use")
                else:
                    node.remove()
                    model.remove(iter0)

            else:
                ln = node.getTags() + node.getCatgs()
                if len(ln)==0:
                    node.remove()
                    model.remove(iter0)
                else:
                    MessageBox(None,"no","Category is not empty")
    ###################################################################################
    #context Window custom methods }

    def on_window_delete_event(self, widget, *args):
        #context Window.on_window_delete_event {
        JBrout.conf["hpaned"] = self.hpaned1.get_position()
        JBrout.conf["width"],JBrout.conf["height"] = self.main_widget.get_size()
        JBrout.db.save()
        JBrout.tags.save()
        JBrout.conf.save()
        gtk.main_quit()
        return False
        #context Window.on_window_delete_event }

    def on_window_size_allocate(self, widget, *args):
        #context Window.on_window_size_allocate {
        #~ self.tbl.set_size_request(100,100)
        x=1

        #~ a=gtk.gdk.Rectangle(0,0,400,400)
        #~ self.tbl.onResize(x,a)
        #context Window.on_window_size_allocate }

    def on_search_activate(self, widget, *args):
        #context Window.on_search_activate {
        MessageBox(self.main_widget,"","""Not implemented yet""")
        #context Window.on_search_activate }

    def on_quitter_activate(self, widget, *args):
        #context Window.on_quitter_activate {
        self.on_window_delete_event(widget,*args)
        #context Window.on_quitter_activate }

    def on_a_propos_activate(self, widget, *args):
        #context Window.on_a_propos_activate {
        MessageBox(self.main_widget,"About","""
        Jbrout %s
        GNU GPL Licence
        http://jbrout.free.fr

        Copyright 2005 by Marc Lentz
        """ % (__version__))
        #context Window.on_a_propos_activate }

    def on_notebook1_switch_page(self, widget, *args):
        #context Window.on_notebook1_switch_page {
        gpoint,page= args
        if page==1: # tab "time"
            self.affdate.set_text( self.selectDate.get_model().init( ) )

        #context Window.on_notebook1_switch_page }

    def on_treeviewdb_drag_data_received(self, widget, *args):
        #context Window.on_treeviewdb_drag_data_received {
        #~ print "drag"
        context, x, y, selection, info, time = args
        #~ print selection.selection
        #~ print selection.target
        #~ print selection.format
        #~ print selection.data

        dragFrom =context.get_source_widget().__class__.__name__

        if dragFrom == "TreeView":
            model = widget.get_model()
            if self.dragFolder:

                drop_info = widget.get_dest_row_at_pos(x, y)
                if drop_info:
                    path, position = drop_info
                    iterTo = model.get_iter(path)

                    _cur = iterTo
                    parents=[model.get_path(_cur)]
                    while 1:
                        _cur = model.iter_parent(_cur)
                        if _cur:
                            parents.append(model.get_path(_cur))
                        else:
                            break
                    if model.get_path(self.dragFolder) not in parents:
                        self.on_move_folder(model,self.dragFolder,iterTo)
                        self.dragFolder=None
                        context.finish(True, False, time)
                    else:
                        beep("Don't drop parents to a child")
                else:
                    beep("Drop in space")
            else:
                beep("Nothing was dragged")
        elif dragFrom == "Item":        # a photo to a folder
            drop_info = widget.get_dest_row_at_pos(x, y)
            model=widget.get_model()
            if drop_info:
                path, position = drop_info
                if position in [gtk.TREE_VIEW_DROP_INTO_OR_BEFORE,gtk.TREE_VIEW_DROP_INTO_OR_AFTER]:
                    iterTo = model.get_iter(path)
                    self.on_drop_photos(model,iterTo)
        else:
            print "drop inconnu"
        context.finish(True,False, time)
        #context Window.on_treeviewdb_drag_data_received }

    def on_treeviewdb_row_expanded(self, widget, *args):
        #context Window.on_treeviewdb_row_expanded {
        iter0,path = args
        model = widget.get_model()
        node = model.get(iter0)
        node.setExpand(True)
        #context Window.on_treeviewdb_row_expanded }

    def on_treeviewdb_row_collapsed(self, widget, *args):
        #context Window.on_treeviewdb_row_collapsed {
        iter0,path = args
        model = widget.get_model()
        node = model.get(iter0)
        node.setExpand(False)
        #context Window.on_treeviewdb_row_collapsed }

    def on_treeviewdb_row_activated(self, widget, *args):
        #context Window.on_treeviewdb_row_activated {
        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()

        self.select( model, iter0 )

        #~ w,h=self.tbl.size_allocate()
        #~ print w,h
        #~ #context Window.on_treeviewdb_row_activated }

    def on_treeviewdb_drag_data_get(self, widget, *args):
        #context Window.on_treeviewdb_drag_data_get {
        #~ context, selection, target_id,etime = args
        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()
        self.dragFolder = iter0
        #~ selection.set(selection.target, 8, "jbrout.folder" )

        #context Window.on_treeviewdb_drag_data_get }

    def on_treeviewdb_button_release_event(self, widget, *args):
        #context Window.on_treeviewdb_button_release_event {

        def makeItem(nom,callback):
            item = gtk.ImageMenuItem(nom)
            item.connect("activate",callback)
            item.show()
            return item

        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()
        if iter0:
            node = model.get(iter0)

            event = args[0]
            if node!=None:
                # on a real folder
                if event.button==3:
                    menu = gtk.Menu()
                    menu.append( makeItem("Select only",self.on_menu_select_only) )
                    if JBrout.modify:
                        menu.append( makeItem("Rename",self.on_menu_rename) )
                        menu.append( makeItem("New folder",self.on_menu_new_folder) )
                        menu.append( makeItem("Refresh",self.on_menu_refresh) )
                        menu.append( makeItem("Remove from db",self.on_menu_delete_from_db) )
                        menu.append( makeItem("Delete from disk",self.on_menu_delete_from_disk) )
                    menu.popup(None,None,None,event.button,0)
                elif event.button==2:
                    self.select(model,iter0,False)
            else:
                # on the basket
                if event.button==3:
                    menu = gtk.Menu()
                    menu.append( makeItem("Remove",self.on_menu_remove_basket) )
                    menu.popup(None,None,None,event.button,0)
                elif event.button==2:
                    self.select(model,iter0)


        #context Window.on_treeviewdb_button_release_event }

    def on_btn_addFolder_clicked(self, widget, *args):
        #context Window.on_btn_addFolder_clicked {
        dialog = gtk.FileChooserDialog ("Add Folder",
             None, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
             (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL, gtk.STOCK_OPEN,
              gtk.RESPONSE_OK))
        dialog.set_default_response (gtk.RESPONSE_OK)
        dialog.set_transient_for (self.main_widget)

        # preselect the previous mount point
        dialog.select_filename (JBrout.conf["addFolderDefaultPath"] or "")

        response = dialog.run ()
        if response == gtk.RESPONSE_OK:
            folder = dialog.get_filename().decode( "utf_8" ) # gtk return utf8
            JBrout.conf["addFolderDefaultPath"] = folder
        else:
            folder = None
        dialog.destroy()

        if folder:
            self.on_drop_folders_from_os(self.treeviewdb.get_model(),[folder])

        #context Window.on_btn_addFolder_clicked }

    def on_btn_addFolder_drag_data_received(self, widget, *args):
        #context Window.on_btn_addFolder_drag_data_received {

        # should only be called on *nix platforms ;-)
        context, x, y, selection, info, time = args

        list=[]
        for uri in selection.data.strip().split("\n"):
            if uri[:7]=="file://":
                file = uri[7:].strip()
                file = file.encode(sys.getfilesystemencoding())
                file = urllib.unquote_plus(file)
                file = file.decode(sys.getfilesystemencoding())
                if os.path.isdir(file):
                    list.append(file)
        if list:
            self.on_drop_folders_from_os(self.treeviewdb.get_model(),list)
        #context Window.on_btn_addFolder_drag_data_received }

    def on_btn_yl_clicked(self, widget, *args):
        #context Window.on_btn_yl_clicked {
        self.affdate.set_text( self.selectDate.get_model().init( -12 ) )

        #context Window.on_btn_yl_clicked }

    def on_btn_ml_clicked(self, widget, *args):
        #context Window.on_btn_ml_clicked {

        self.affdate.set_text( self.selectDate.get_model().init( -1 ) )

        #context Window.on_btn_ml_clicked }

    def on_btl_mm_clicked(self, widget, *args):
        #context Window.on_btl_mm_clicked {

        self.affdate.set_text( self.selectDate.get_model().init( 1 ) )

        #context Window.on_btl_mm_clicked }

    def on_btn_ym_clicked(self, widget, *args):
        #context Window.on_btn_ym_clicked {

        self.affdate.set_text( self.selectDate.get_model().init( 12 ) )

        #context Window.on_btn_ym_clicked }

    def on_selectDate_row_activated(self, widget, *args):
        #context Window.on_selectDate_row_activated {

        treeselection = widget.get_selection()
        model, iter0 = treeselection.get_selected()
        ymd = model.get_value(iter0,2)
        name = model.get_value(iter0,0)+" "+self.affdate.get_text()

        self.showProgress(True)
        try:
            ln = JBrout.db.select("""//photo[substring(@date,1,8)="%s"]""" % ymd)
            self.SetSelection(name,ln,Window.MODETIME)
        finally:
            self.showProgress()

        #context Window.on_selectDate_row_activated }

    def on_treeviewtags_row_activated(self, widget, *args):
        #context Window.on_treeviewtags_row_activated {
        treeselection = widget.get_selection()
        model,paths = treeselection.get_selected_rows()
        if len(paths)==1:
            iter0 = model.get_iter(paths[0])
            node = model.get(iter0)
            if node.__class__.__name__ == "TagNode":
                tag = node.name
                xpath = 't="%s"'%tag
                npath = "Tag %s"%tag
            else:
                l = [i.name for i in node.getAllTags()]
                if l:
                    xpath = " or ".join( ['t="%s"'%t for t in l] )
                    npath = "Tags "+(", ".join( ['%s'%t for t in l] ))
                else:
                    xpath=None

            if xpath:
                self.showProgress(True)
                try:
                    ln = JBrout.db.select("""//photo[%s]""" % xpath)
                    self.SetSelection(npath,ln,Window.MODETAG)
                finally:
                    self.showProgress()

        #context Window.on_treeviewtags_row_activated }

    def on_treeviewtags_row_collapsed(self, widget, *args):
        #context Window.on_treeviewtags_row_collapsed {
        iter0,path = args
        model = widget.get_model()
        node = model.get(iter0)
        node.setExpand(False)
        #context Window.on_treeviewtags_row_collapsed }

    def on_treeviewtags_row_expanded(self, widget, *args):
        #context Window.on_treeviewtags_row_expanded {
        iter0,path = args
        model = widget.get_model()
        node = model.get(iter0)
        node.setExpand(True)
        #context Window.on_treeviewtags_row_expanded }

    def on_treeviewtags_drag_data_get(self, widget, *args):
        #context Window.on_treeviewtags_drag_data_get {
        context, selection, target_id,etime = args
        treeselection = widget.get_selection()
        model,paths = treeselection.get_selected_rows()
        iters = [model.get_iter(i) for i in paths]
        self.dragTags = iters
        selection.set(selection.target, 8, "tags" )

        #context Window.on_treeviewtags_drag_data_get }

    def on_treeviewtags_drag_data_received(self, widget, *args):
        #context Window.on_treeviewtags_drag_data_received {
        #~ print "drag"
        context, x, y, selection, info, time = args
        #~ print selection.selection
        #~ print selection.target
        #~ print selection.format
        #~ print selection.data

        dragFrom =context.get_source_widget().__class__.__name__

        model = widget.get_model()

        drop_info = widget.get_dest_row_at_pos(x, y)
        if drop_info:
            path, position = drop_info
            iterTo = model.get_iter(path)
            if self.dragTags:
                nodeTo = model.get(iterTo)
                if nodeTo.__class__.__name__=="TagNode":
                    beep("Don't drop tags on a tag")
                else:
                    moved=False
                    for i in self.dragTags:
                        node = model.get(i) # node can be a TagNode or a CatgNode

                        _cur = iterTo
                        parents=[model.get_path(_cur)]
                        while 1:
                            _cur = model.iter_parent(_cur)
                            if _cur:
                                parents.append(model.get_path(_cur))
                            else:
                                break

                        if model.get_path(i) not in parents:
                            node.moveToCatg(nodeTo)
                            moved=True
                        else:
                            beep("Tag/catg couldn't be a parent of the destination")

                    if moved:
                        model.init()
                        model.expander(self.treeviewtags)

            else:
                beep("Nothing was dragged")
        else:
            beep("Drop in space")

                    #~ _cur = iterTo
                    #~ parents=[model.get_path(_cur)]
                    #~ while 1:
                        #~ _cur = model.iter_parent(_cur)
                        #~ if _cur:
                            #~ parents.append(model.get_path(_cur))
                        #~ else:
                            #~ break
                    #~ if model.get_path(self.dragFolder) not in parents:
                        #~ self.on_move_folder(model,self.dragFolder,iterTo)
                        #~ self.dragFolder=None
        context.finish(True, False, time)

        #context Window.on_treeviewtags_drag_data_received }

    def on_treeviewtags_button_release_event(self, widget, *args):
        #context Window.on_treeviewtags_button_release_event {

        def makeItem(nom,callback):
            item = gtk.ImageMenuItem(nom)
            item.connect("activate",callback)
            item.show()
            return item

        if JBrout.modify:
            event = args[0]
            treeselection = widget.get_selection()
            model,paths = treeselection.get_selected_rows()
            if len(paths)==1:
                iter0 = model.get_iter(paths[0])
                #~ model, iter0 = treeselection.get_selected()
                node = model.get(iter0)
                if event.button==3:
                    menu = gtk.Menu()
                    if node.__class__.__name__ == "CatgNode":
                        menu.append( makeItem("Add Tag",self.on_menu_add_tag) )
                        menu.append( makeItem("Add Catg",self.on_menu_add_catg) )
                    menu.append( makeItem("Delete tag/catg",self.on_menu_delete_tags) )
                    menu.popup(None,None,None,event.button,0)

        #context Window.on_treeviewtags_button_release_event }

    def on_treeviewtags_cursor_changed(self, widget, *args):
        #context Window.on_treeviewtags_cursor_changed {
        pass

        #context Window.on_treeviewtags_cursor_changed }

def main():
    if sys.platform[:3] != 'win':
        gtk.gdk.threads_init()

    sys.excepthook = myExceptHook

    JBrout.init(True)

    gtk.window_set_default_icon_from_file("gfx/jbrout.ico")
    window = Window()

    JPlugin.initialize(window)
    window.run()

if __name__ == "__main__":

    main()
